// Please, don't delete this comment. \\
(*
  Copyright Owner: coltishWARE (Kevin Niehage)
  Copyright Year : 2007-2008

  Include: MWconnU3 (platform independant)
  Version: 0.6c

  Contact E-Mail            : development@coltishWARE.com
  Contact Mobile            : +49-(0)-177-69-4321-8
  Contact Telephone Berlin  : +49-(0)-30-69-20-96-78
  Contact Telephone Cottbus : +49-(0)-355-28925-88-17-55
  Contact Telephone Mannheim: +49-(0)-621-483-4664
*)
// Please, don't delete this comment. \\

(*
  Description:

  This include file contains the definition of the type TMWconnIO_2.
*)

(*
  Change Log:

  // See "Change Log" of File "MWconnU.pas" for Information.
*)

(* VERSION 3
typedef struct { // Struktur fr Datenaustausch mit externen Programmen
  unsigned long len; // Lnge dieser Struktur in Bytes

  unsigned short structure_version; // Version dieser Struktur: 3
  unsigned short program_version;   // Version des MWconn-Programms
                                    // (Hauptversion*256+Nebenversion)

  unsigned long res1[3]; // reserviert

  // Datenrichtung extern->MWconn
  char command[100]; // von MWconn auszufhrendes Kommando;
                     // "MWCONN_CONNECT": verbinden;
                     // "MWCONN_DISCONNECT": trennen;
                     // "MWCONN_RECONNECT": neu verbinden;
                     // "MWCONN_END": Programm beenden;
                     // ":::ATI": AT-Kommando an Gert senden (hier "ATI");
                     // bei Novatel-Gerten nur mit Novatel-DLL;
                     // ":250:4000:ATI": desgleichen, jedoch mit
                     // Wartezeitangaben, 250ms nach dem Senden
                     // beginnt der Empfang, welcher maximal 4 weitere
                     // Sekunden spter abgeschlossen sein muss;

  // Datenrichtung MWconn->extern
  // Hinweis: nicht alle Datenkarten untersttzen alle Informationen;
  unsigned long process_counter; // dieser Zhler wird von MWconn mit
                                 // jedem Verarbeitungstakt inkrementiert;
  unsigned long volume;          // summiertes Datenvolumen in kBytes
  unsigned long time;            // summierte Onlinezeit in Minuten
  unsigned long online_time;     // aktuelle Onlinezeit in Sekunden; ==0: offline
  unsigned long offline_time;    // aktuelle/letzte Offline-Zeit in Sekunden
  unsigned long upspeed;         // aktuelle Sendegeschwindigkeit in Bytes/s
  unsigned long downspeed;       // aktuelle Empfangsgeschwindigkeit in Bytes/s
  unsigned char opmode;          // Betriebsart; 0: nicht bekannt; 1: GPRS; 2: UMTS;
  unsigned char signal_raw;      // Signalstrke als GSM-Standardwert (0..31)
  unsigned char signal_percent;  // Signalstrke in Prozent (0..100);
                                 // nur gltig, wenn signal_raw>0
  signed short signal_dbm;       // Signalstrke in dBm
  char network_name[30+1+1];     // Name des Netzwerks
  char plmn[6+1];                // Public Land Mobile Network, bestehend aus MCC und MNC
  char lac[4+1];                 // Location Area Code
  char cid[4+1];                 // Cell-ID
  char message[64+1];            // ggf. Meldungstext
  char mini_message[48+1];       // ggf. verkrzter Meldungstext
  char error_message[32+1];      // ggf. Fehlermeldung

  unsigned char res2[3]; // reserviert
  unsigned long res3[7]; // reserviert

  char answer[600]; // Antwort auf AT-Kommando
} mwcio_t;
VERSION 3 *)

type
  TMWconnIO_3 = record
    Len : LongWord;

    Structure_Version : Word;
    Program_Version   : Word;

    Res1 : array [0..2] of LongWord;

    Command : array [0..99] of Char;

    Process_Counter : LongWord;

    Volume         : LongWord;
    Time           : LongWord;
    Online_Time    : LongWord;
    Offline_Time   : LongWord;
    UpSpeed        : LongWord;
    DownSpeed      : LongWord;
    OpMode         : Byte; // unsigned char
    Signal_Raw     : Byte; // unsigned char
    Signal_Percent : Byte; // unsigned char
    Signal_DBM     : SmallInt;
    Network_Name   : array [0..31] of Char;
    PLMN           : array [0..6]  of Char;
    LAC            : array [0..4]  of Char;
    CID            : array [0..4]  of Char;
    Message        : array [0..64] of Char;
    Mini_Message   : array [0..48] of Char;
    Error_Message  : array [0..32] of Char;

    Res2 : array [0..2] of Byte; // unsigned char
    Res3 : array [0..6] of LongWord;

    Answer : array [0..599] of Char;
  end;

